const MAX_RETRIES = 3;
let retries = 0;

function tryLoadingWHMEventSource(messageHandler) {
  setTimeout(() => {
    if (!window.__whmEventSourceWrapper) {
      if (retries >= MAX_RETRIES) return;
      retries++;
      tryLoadingWHMEventSource(messageHandler);
      return;
    }

    const eventSource = Object.values(window.__whmEventSourceWrapper)[0];
    eventSource.addMessageListener(event => {
      try {
        const message = JSON.parse(event.data);
        messageHandler(message);
      } catch (e) {
        // heartbeat
        if (event.data === '💓') {
          return;
        }

        console.error(e);
      }
    });
  }, 1000);
}

module.exports = tryLoadingWHMEventSource;
